%% ** The Imperial PEPA compiler:
%% ipc v1.01-rc0 260504 ("Peter Cushing" Release)
%% DNAmaca generator: Jeremy Bradley; PEPA parser: Stephen Gilmore
%% Incorporating Sven Panne's port of the GNU GetOpt library
%% Produced on location in/between Edinburgh, Leeds, London and Ludlow, 2002-4
%% Mail queries and problems to: jb@doc.ic.ac.uk
\model {
	\header{#define ipcmin(a,b) (a < b) ? (a) : (b)}
	
	
	%% Alter the rate constant(s) below as desired:
	\constant{PEPA_r}{1.0}
	
	
	\statevector {
		\type{short} {
			_CliProbe_0_1, _CliProbe_run_0_1,
			P1_0_2, P3_0_2,
			P2_0_2, Q1_0_3,
			Q3_0_3, Q2_0_3
		}
	}
	
	\initial {
		_CliProbe_0_1	 = 1;
		_CliProbe_run_0_1	 = 0;
		P1_0_2	 = 1;
		P3_0_2	 = 0;
		P2_0_2	 = 0;
		Q1_0_3	 = 1;
		Q3_0_3	 = 0;
		Q2_0_3	 = 0;
	}
	
	\transition{1_P2_0_2_run_P} {
		%% PEPA action type { run_P }
		\condition{ P2_0_2 > 0 }
		\action {
			next -> P2_0_2 = P2_0_2 - 1;
			next -> P3_0_2 = P3_0_2 + 1;
		}
		\priority{1}
		\rate{ PEPA_r }
	}
	
	\transition{2_Q1_0_3_start_Q} {
		%% PEPA action type { start_Q }
		\condition{ Q1_0_3 > 0 }
		\action {
			next -> Q1_0_3 = Q1_0_3 - 1;
			next -> Q2_0_3 = Q2_0_3 + 1;
		}
		\priority{1}
		\rate{ PEPA_r }
	}
	
	\transition{3_Q2_0_3_run_Q} {
		%% PEPA action type { run_Q }
		\condition{ Q2_0_3 > 0 }
		\action {
			next -> Q2_0_3 = Q2_0_3 - 1;
			next -> Q3_0_3 = Q3_0_3 + 1;
		}
		\priority{1}
		\rate{ PEPA_r }
	}
	
	\transition{4_Q3_0_3_stop_Q} {
		%% PEPA action type { stop_Q }
		\condition{ Q3_0_3 > 0 }
		\action {
			next -> Q3_0_3 = Q3_0_3 - 1;
			next -> Q1_0_3 = Q1_0_3 + 1;
		}
		\priority{1}
		\rate{ PEPA_r }
	}
	
	\transition{5__CliProbe_0_1_start_P__P1_0_2_start_P} {
		%% PEPA action type { start_P }
		\condition{ (_CliProbe_0_1 > 0) && (P1_0_2 > 0) }
		\action {
			next -> P1_0_2 = P1_0_2 - 1;
			next -> P2_0_2 = P2_0_2 + 1;
			next -> _CliProbe_0_1 = _CliProbe_0_1 - 1;
			next -> _CliProbe_run_0_1 = _CliProbe_run_0_1 + 1;
		}
		\priority{1}
		\rate{ ( 1.0 / ( 1.0 + ( (_CliProbe_run_0_1 > 0) ? 1.0 : 0.0 ) ) ) * PEPA_r }
	}
	
	\transition{6__CliProbe_run_0_1_start_P__P1_0_2_start_P} {
		%% PEPA action type { start_P }
		\condition{ (_CliProbe_run_0_1 > 0) && (P1_0_2 > 0) }
		\action {
			next -> P1_0_2 = P1_0_2 - 1;
			next -> P2_0_2 = P2_0_2 + 1;
		}
		\priority{1}
		\rate{ ( 1.0 / ( 1.0 + ( (_CliProbe_0_1 > 0) ? 1.0 : 0.0 ) ) ) * PEPA_r }
	}
	
	\transition{7__CliProbe_run_0_1_stop_P__P3_0_2_stop_P} {
		%% PEPA action type { stop_P }
		\condition{ (_CliProbe_run_0_1 > 0) && (P3_0_2 > 0) }
		\action {
			next -> P3_0_2 = P3_0_2 - 1;
			next -> P1_0_2 = P1_0_2 + 1;
			next -> _CliProbe_run_0_1 = _CliProbe_run_0_1 - 1;
			next -> _CliProbe_0_1 = _CliProbe_0_1 + 1;
		}
		\priority{1}
		\rate{ ( 1.0 / ( 1.0 + ( (_CliProbe_0_1 > 0) ? 1.0 : 0.0 ) ) ) * PEPA_r }
	}
	
	\transition{8__CliProbe_0_1_stop_P__P3_0_2_stop_P} {
		%% PEPA action type { stop_P }
		\condition{ (_CliProbe_0_1 > 0) && (P3_0_2 > 0) }
		\action {
			next -> P3_0_2 = P3_0_2 - 1;
			next -> P1_0_2 = P1_0_2 + 1;
		}
		\priority{1}
		\rate{ ( 1.0 / ( 1.0 + ( (_CliProbe_run_0_1 > 0) ? 1.0 : 0.0 ) ) ) * PEPA_r }
	}
	
}

%% Analysis specification

%% Steady-state solution control
\solution {
	%% Choice of methods - choose alternative, as appropriate,
	%% from list below if convergence is slow:
	%% gauss, grassman, gauss_seidel, sor, bicg, cgnr
	%% bicgstab, bicgstab2, cgs, tfqmr, ai, air, automatic
	
	\method{ sor }
}



%% Passage specification
\passage {
	\sourcecondition{ _CliProbe_run_0_1 > 0 }
	\targetcondition{ _CliProbe_0_1 > 0 }
	%% Alter time range figures below as required:
	\t_start{0.1}
	\t_stop{10.0}
	\t_step{0.1}
	
}


