\model{

\constant{CAPACITY}{100}
\constant{LAMBDA}{4}
\constant{MU}{48}
\constant{KK}{4}

\statevector{
  \type{int}{n1, n2}
}

\initial{
  n1 = 1;
  n2 = 0;
}

\transition{arrival}{
  \condition{n1 < CAPACITY && (n1+n2 !=0) && (n1+n2 !=KK)}
  \action {        
    next->n1 = n1 + 1; 
  }  
  \rate{ LAMBDA }
}

\transition{service1}{
  \condition{n1 > 0 && n2 < CAPACITY && (n1+n2 !=0) && (n1+n2 !=KK)}
  \action{
    next->n1 = n1 - 1;
    next->n2 = n2 + 1;
  }
  \rate{ MU }
}

\transition{service2}{
  \condition{n2 > 0 && (n1+n2 !=0) && (n1+n2 !=KK)}
  \action{
    next->n2 = n2 - 1; 
  }  
  \rate{ MU }
}

}

%\performance{
%  \statemeasure{n1 stats}{
%    \estimator{mean variance distribution}
%    \expression{n1}
%  }
%
%  \statemeasure{n2 stats}{
%    \estimator{mean variance distribution}
%    \expression{n2}
%  }
%
%  \statemeasure{pop stats}{
%    \estimator{mean variance distribution}
%    \expression{(n1 + n2)}
%  }
%
%
%}

\solution{
  \method{sor}
}

\transient{
%  \targetcondition{ (n1 + n2 == 0) }
  \targetcondition{ (n1 + n2 == KK) }
  \sourcecondition{ (n1 == 1) && (n2 == 0) }
  \t_start{8.0}
  \t_stop{12.0}
  \t_step{1.0}
}

