class HashTableEntry {
protected:
  unsigned long secondaryKey;
  long target;
public:
  HashTableEntry() {}
  ~HashTableEntry() {}

  inline void setSecondaryKey(unsigned long _secondaryKey) { secondaryKey = _secondaryKey; }
  inline void setTarget(long _target) { target = _target; }
  inline unsigned long getSecondaryKey() const { return secondaryKey; }
  inline long getTarget() const { return target; }

  inline int operator==(const HashTableEntry &source) { 
    return secondaryKey == source.secondaryKey;
  }
  friend ostream &operator<<(ostream &out, const HashTableEntry &source);
};

class StateHashTableRow {
protected:
  long entries;
  FastDynaArray<HashTableEntry> element;
public:
  StateHashTableRow() { entries = 0; }
  ~StateHashTableRow() {}
  inline void add(unsigned long secondary, long target) {
    element.check(entries);
    element[entries].setSecondaryKey(secondary);
    element[entries].setTarget(target);
    entries++;
  }
  inline int search(unsigned long secondary, long &id) const {
    for (long n=0; n<entries; n++)
      if (element(n).getSecondaryKey() == secondary) {
        id = element(n).getTarget();
        #ifdef VERBOSE
        cout << "StateHashTableRow (" << this << "): search successful (state number " << id << ")\n";
        #endif
        return 1;
      }
    #ifdef VERBOSE
    cout << "StateHashTableRow (" << this << "): search failed.\n";
    #endif
    return 0;
  }
  inline long getEntries() const { return entries; }
};
