class Information {
protected:
  int maxChildren;
  long tangible, trans;
  
  long transitions;
  TransType *transType;
  int *priority;
  int stateMeasures, countMeasures;
  int *stateEstimator, *countEstimator;
  long maxStates, maxIterations;
  long genRepInterval, solRepInterval;
  double maxCPUTime, accuracy, relaxParameter, maxRate;
  int dynamic;
  long stateSize;
  int safeHash;
  double t_start, t_stop, t_step;
  int doSteady, doPassage, doTransient;
  long sources, targets, excludeds;
  char checksum[128];

  ReportStyle genRepStyle, solRepStyle;
  SolutionMethod method;

  int parse, generation, functional, steady, reducible, deadlock;

  char stateListFile[MAX_LENGTH], steadyStateFile[MAX_LENGTH], transitionMatrixFile[MAX_LENGTH], resultsFile[MAX_LENGTH], startVectorFile[MAX_LENGTH];

  FastDynaArray<char *> statem, countm;

  int openFile(char *filename, FILE *&fp, char *access, char *buff) const;
  int closeFile(FILE *fp) const;
public:
  Information();
  int output(char *filename) const;
  int outputStateInfo(char *filename) const;
  int input(char *filename);
  int inputStateInfo(char *filename);
  inline int getMaxChildren() const { return maxChildren; }
  inline long getTrans() const { return trans; }
  inline long getTangible() const { return tangible; }
  inline int getTransitions() const { return transitions; }
  inline TransType getTransType(int n) const { return transType[n]; }
  inline TransType *getTransType() const { return transType; }
  inline int *getPriority() const { return priority; }
  inline int getPriority(int n) const { return priority[n]; }
  inline int getStateMeasures() const { return stateMeasures; }
  inline int getCountMeasures() const { return countMeasures; }
  inline long getMaxStates() const { return maxStates; }
  inline long getMaxIterations() const { return maxIterations ; }
  inline long getGenRepInterval() const { return genRepInterval; }
  inline long getSolRepInterval() const { return solRepInterval; }
  inline double getMaxCPUTime() const { return maxCPUTime; }
  inline int getSafeHash() const { return safeHash; }
  inline double getAccuracy() const { return accuracy; }
  inline double getMaxRate() const { return maxRate; }
  inline double getRelaxParameter() const { return relaxParameter; }
  inline int getDynamic() const { return dynamic; }
  inline ReportStyle getGenRepStyle() const { return genRepStyle; }
  inline ReportStyle getSolRepStyle() const { return solRepStyle; }
  inline SolutionMethod getMethod() const { return method; }
  inline char *getStateListFile() { return stateListFile; }
  inline char *getSteadyStateFile() { return steadyStateFile; }
  inline char *getStartVectorFile() { return startVectorFile; }
  inline char *getTransMatrixFile() { return transitionMatrixFile; }
  inline char *getStateName(int index) { return statem(index); }
  inline char *getCountName(int index) { return countm(index); }
  inline int getStateEstimator(int index) { return stateEstimator[index]; }
  inline int getCountEstimator(int index) { return countEstimator[index]; }
  inline long getStateSize() { return stateSize; }
  inline char *getChecksum() { return checksum; }

  inline int getParse() { return parse; }
  inline int getGeneration() { return generation; }
  inline int getFunctional() { return functional; }
  inline int getSteady() { return steady; }
  inline int getReducible() { return reducible; }
  inline int getDeadlock() { return deadlock; }

  inline double getTStart() { return t_start; }
  inline double getTStop() { return t_stop; }
  inline double getTStep() { return t_step; }

  inline long getSources() { return sources; }
  inline long getTargets() { return targets; }
  inline long getExcludeds() { return excludeds; }

  inline int getDoSteady() { return doSteady; }
  inline int getPassage() { return doPassage; }
  inline int getTransient() { return doTransient; }

  void setParse(int _parse) { parse = _parse; }
  void setGeneration(int _generation) { generation = _generation; }
  void setFunctional(int _functional) { functional = _functional; }
  void setSteady(int _steady) { steady = _steady; }
  void setReducible(int _reducible) { reducible = _reducible; }
  void setDeadlock(int _deadlock) { deadlock = _deadlock; }
  void setChecksum(char *c) { strcpy(checksum, c); }

  void setMaxChildren(int _maxChildren) { maxChildren = _maxChildren; }
  void setTrans(int _trans) { trans = _trans; }
  void setTangible(int _tangible) { tangible = _tangible; }
  void setTransitions(int _transitions) {
    transitions = _transitions;
    transType = new TransType[transitions]; 
    priority = new int[transitions];
  }
  void setTransType(int index, TransType type) { transType[index] = type; }
  void setPriority(int index, int prior) { priority[index] = prior; }
  void setStateMeasures(int _sm) { stateMeasures = _sm; }
  void setCountMeasures(int _cm) { countMeasures = _cm; }
  void setMaxStates(long _ms) { maxStates = _ms; }
  void setMaxIterations(long _mi) { maxIterations = _mi; }
  void setGenRepInterval(long _gi) { genRepInterval = _gi; }
  void setSolRepInterval(long _si) { solRepInterval = _si; }
  void setMaxCPUTime(double _mct) { maxCPUTime = _mct; }
  void setMaxRate(double _mr) { maxRate = _mr; }
  void setSafeHash(int _sh) { safeHash = _sh; }
  void setAccuracy(double _accuracy) { accuracy = _accuracy; }
  void setRelaxParameter (double _rp) { relaxParameter = _rp; }
  void setDynamic(int _dynamic) { dynamic = _dynamic; }
  void setGenRepStyle(ReportStyle _gs) { genRepStyle = _gs; }
  void setSolRepStyle(ReportStyle _ss) { solRepStyle = _ss; }
  void setMethod(SolutionMethod _sm) { method = _sm; }
  void setStateListFile(char *_slf) { strcpy(stateListFile, _slf); }
  void setStartVectorFile(char *_svf) { strcpy(startVectorFile, _svf); }
  void setSteadyStateFile(char *_ssf) { strcpy(steadyStateFile, _ssf); }
  void setTransitionMatrixFile(char *_tmf) {
    strcpy(transitionMatrixFile, _tmf); }
  void setStateName(int index, char *name);
  void setCountName(int index, char *name);
  inline void setStateEstimator(int *value) { stateEstimator = value; }
  inline void setCountEstimator(int *value) { countEstimator = value; }
  inline void setStateSize(long _ss) { stateSize = _ss; }

  void setTStart(double _ts) { t_start = _ts; }
  void setTStop(double _ts) { t_stop = _ts; }
  void setTStep(double _ts) { t_step = _ts; }

  void setSources(long _s) { sources = _s; }
  void setTargets(long _t) { targets = _t; }
  void setExcludeds(long _e) { excludeds = _e; }

  void setDoSteady(int _s) { doSteady = _s; }
  void setPassage(int _p) { doPassage = _p; }
  void setTransient(int _t) { doTransient = _t; }

};

