class ValueCache {
protected:
  FastDynaArray<_complex_> key;
  FastDynaArray<_complex_> value;
  int _pairs;
public:
  ValueCache() { _pairs = 0; }

  _complex_ *get(_complex_ _key) {
    for (int n=0; n<_pairs; n++) {
      if ( fabs(key[n].real() - _key.real() ) < 1e-10 && 
	   fabs(key[n].imag() - _key.imag() ) < 1e-10 )
	return &value[n];
    }
    return NULL;
  }

  int add(_complex_ _key, _complex_ _value) {
    _complex_ *target = get(_key);
    if (target) {
      *target = _value;
      return 0;
    }
    key.check(_pairs);
    value.check(_pairs);
    key[_pairs] = _key;
    value[_pairs] = _value;
    _pairs++;
    return 1;
  }

  int pairs() { return _pairs; }
  void reset() {
    _pairs = 0;
    key.setLength(0);
    value.setLength(0);
  }
};
